<?php
$NO_JSON_OUT = 1; //include mode for ipinfo.php

require_once("include/config.php");
require_once("include/ipinfo.php");

?>
<!DOCTYPE html>
<html lang="de">
<head>
	<meta charset="UTF-8"> 
	<title>Netzwerktest (<?php echo $ip["name"]; ?>)</title>
	<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">
	<link rel="apple-touch-icon" sizes="180x180" href="/apple-touch-icon.png">
    <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png">
    <link rel="manifest" href="/site.webmanifest">
    <link rel="mask-icon" href="/safari-pinned-tab.svg" color="#5bbad5">
    <meta name="msapplication-TileColor" content="#e0e8ff">
    <meta name="theme-color" content="#b7eeff">
	<link rel="stylesheet" type="text/css" href="style.css">
</head>
<body>
	<div class="cont">

		<h1><a class="title" href="//<?php echo $ip["host"].$config["app_path"]; ?>">
			<?php echo $ip["name"]; ?> - Testseite
		</a></h1>
		
		
		<hr>
		<div class="ipTest">
			<div class="ip_v4"><div class="info_ip">Warte auf IPv4 <div class="lds-ellipsis"><div></div><div></div><div></div><div></div></div></div><div class="info_geo"></div></div>
			<hr style="margin-top:0;margin-bottom:0;">
			<div class="ip_v6"><div class="info_ip">Warte auf IPv6 <div class="lds-ellipsis"><div></div><div></div><div></div><div></div></div></div><div class="info_geo"></div></div>
			<div class="ip_ds" style="display:none;"><div class="info_ip"></div><div class="info_geo"></div></div>
		</div>
		<hr>
		<h3>Informationen & Downloads</h3>
		<div id="resultExplanation"></div>
		<?php
		if($ip["conHostType"] == 1)
		{
			if($ip["conClientType"]==0)
			{
				echo "Dein Browser hat <b>IPv4</b> ausgewählt, um sich zu verbinden!<br>";
			}
			else
			{
				echo "Dein Browser hat <b>IPv6</b> ausgewählt, um sich zu verbinden!<br>";
			}
		}
		else {
			echo "Wenn diese Seite angezeigt wird unterstützt der Client <b>".$ip["name"]."</b>!<br>";
		}
		
		if(isset($_SERVER['HTTPS']) && "on" == $_SERVER['HTTPS'])
		{
			echo "Du bist mit <b>https</b> verbunden.";
		}
		else
		{
			echo "Du bist mit <b>http</b> verbunden.";
		}
		?>
		<p>Download mit <?php echo $ip["name"]; ?>:
		<a href="1MB.zip">1MB Download</a>, 
		<a href="10MB.zip">10MB Download</a>, 
		<a href="100MB.zip">100MB Download</a></p>
		
		<p>Weitere Informationen: 
		<a href="//<?php echo $config["nameDS"]; ?>/raw/" target="_blank">Nur IP Adresse als Text</a>, &nbsp; 
		<a href="//status.zuim.de/" target="_blank">Server Statusseite</a>, &nbsp; 
		<a href="//zuim.de/" target="_blank">zuim.de Hauptseite </a></p>
		<hr>
		
		<h3 class='headCont'>
		Rufe diese Seite direkt über 
		 <a href="https://<?php echo $config["namev4"] . $config["app_path"]; ?>"> IPV4</a>
		 <a href="http://<?php echo $config["ipv4"] . $config["app_path"]; ?>" class="secondary_link">(Ohne DNS)</a> &nbsp;
		 <a href="https://<?php echo $config["nameDS"] . $config["app_path"]; ?>">Dualstack</a> &nbsp; 
		 <a href="http://<?php echo $config["namev6"] . $config["app_path"]; ?>"> IPV6</a>
		 <a href="http://[<?php echo $config["ipv6"]."]" . $config["app_path"]; ?>" class="secondary_link">(Ohne DNS)</a> 
		 auf.</h3>
		<noscript>Aktiviere Javascript, für mehr Informationen:<br>IP: <?php echo $ip["ip"]; ?></noscript>
		
		<hr>
		<h3>Ping mit Graph messen: <button class="start">Start</button></h3>
		
		<div class="out"></div>
		<div class="ct-chart ct-octave" style="display: none;"></div>
		<hr>
		<h3>Andere Tests für Geschwindigkeit & Ping:</h3>
		<a href="//craftandbuild.de/speedtest/speedtest_ajax">Speedtest mit ajax</a> &nbsp; 
		<a href="//craftandbuild.de/speedtest/speedtest_websocket">Speedtest mit websocket</a> &nbsp; 
		<a href="//craftandbuild.de/WebSockets/Pingtest">Pingtest mit websocket</a>
		<a href="/librespeed/">LibreSpeed Instanz</a>
		<button class="ping"><?php echo $ip["name"]; ?> Ping</button><br><span class="pingresult"></span>
		<hr>
		<h3>Bild(14MB) parallel mit IPv4 und IPv6 laden: <button class="speed">Start</button></h3>
		<div class="images">
		<div class="v4">
			<h3>IPv4</h3>
			<img class="testimg" src="" alt="v4 Test"/>
			<p></p>
		</div>
		<div class="v6">
			<h3>IPv6</h3>
			<img class="testimg" src="" alt="v6 Test"/>
			<p></p>
		</div>
		<br style="clear:both;">
		<h3 class="ausg"></h3>
		</div>
		<br>
    </div>
	
	
<!-- libs -->
	<script src="//cdn.zuim.de/js/jQuery/jquery.js"></script>
	<script defer src="//cdn.zuim.de/js/socket.io-4.1.2.js"></script>
	<script defer src="//cdn.zuim.de/js/chartist-js-0.11.4/chartist.min.js"></script>
	<script defer src="//cdn.zuim.de/js/chartist-js-0.11.4/chartist-plugin-axistitle.min.js"></script>
    <script defer src="//cdn.zuim.de/js/chartist-js-0.11.4/chartist-plugin-legend.js"></script>

	<link rel="stylesheet" href="//cdn.zuim.de/css/chartist.min.css">
<!-- scripts -->
	<script>
	var config = <?php echo json_encode($config); ?>;
	var ipInfo_php = <?php echo json_encode($ip); ?>;
	</script>
	
	<script src="script.js"></script>
</body>
</html>
